#include <stdio.h>
#include <stdarg.h>
#include <process.h>
#include <windows.h>
#include "resource.h"

#define VERSION "ver 0.1"

BOOL CALLBACK DlgProc1(HWND,UINT,WPARAM,LPARAM);
int load(char*filename);

HWND hDlg;

//fobO[hƃfobO₷悤DOSʂoprintfo悤ɂB
//#ifndef _DEBUG
//#define _DEBUG
//#endif

#ifdef _DEBUG
HANDLE hIn;
HANDLE hOut;
HANDLE hErr;
#endif

int printf(char*str,...){
#ifdef _DEBUG
	char pos[128];
	int r;
	va_list ap;
	va_start(ap,str);
	r=vsprintf(pos,str,ap);
	//R\[ւ̏o
	WriteFile(hOut,pos,strlen(pos),NULL,NULL);
	va_end(ap);//ψXg̏I
	return r;
#else
	return 0;
#endif
}

int bitcount(unsigned long n)
{
    n -= n >> 1 & 0x55555555;
    n = (n & 0x33333333) + (n >> 2 & 0x33333333);
    n = (n + (n >> 4)) & 0x0f0f0f0f;
    n += n >> 8;
    return (n + (n >> 16)) & 0xff;
}

int WINAPI WinMain(HINSTANCE hCurInst,HINSTANCE hPrevInst,
					LPSTR lpsCmdLine,int nCmdShow ){

#ifdef _DEBUG
	//R\[쐬
	FreeConsole();
	AllocConsole();
	hIn = GetStdHandle(STD_INPUT_HANDLE);
	hOut = GetStdHandle(STD_OUTPUT_HANDLE);
	hErr = GetStdHandle(STD_ERROR_HANDLE);
#endif

	if(*lpsCmdLine){
		if('\"'==lpsCmdLine[0]){
			lpsCmdLine++;
			char*c=lpsCmdLine;
			while(*++c);c--;
			if('\"'==*c) *c='\0';
		}
		printf("%s\n",lpsCmdLine);
		load(lpsCmdLine);
	}

	hDlg=CreateDialog(hCurInst,MAKEINTRESOURCE(IDD_DIALOG1),NULL,(DLGPROC)DlgProc1);
	ShowWindow(hDlg,SW_NORMAL);					
						
	MSG msg;
	BOOL bRet;

	while((bRet = GetMessage(&msg,NULL,0,0)) != 0){
		if(bRet == -1){
			MessageBox(NULL,"GetMessage ERR","Error",MB_OK);
			break;
		}else{
			if(!IsDialogMessage(hDlg,&msg)){ //TABL[ŃRg[ړɕKv
				TranslateMessage(&msg); 
				DispatchMessage(&msg); 
			} 
		}
	}
	return (int)msg.wParam;
}

//32bit̃}XN8bit݂̂ĂԂɐ`
void fix8bit(unsigned long*data){
	unsigned long pos=0x80000000;
	int count=0;
	while(pos){
		if(8==count){
			(*data)=(~pos)&(*data);
		}else if((*data)&pos){
			count++;
		}
		pos=pos>>1;
	}
}

//Frbg 1 ̕`
void paint1(HDC hdc,unsigned char*data,signed long height,unsigned long width){
	//̃oCgvZ@l̔{ɂ邽߂̋lߕvZB
	unsigned long packing=0;
	const int mask[]={0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};
	unsigned long pos=width;
	if(width%8) pos=width+(8-width%8);
	pos=pos/8;
	if(pos%4)	packing=4-(pos%4);

	unsigned int i=0;
	if(0<(long)height){
		for(signed int h=height-1;0<=h;h--){
			for(unsigned int w=0;w<width;w++){
				if(0==w%8)i++;
				if(mask[w%8]&data[i-1]) SetPixel(hdc,w+0,h,0xFFFFFF); else SetPixel(hdc,w+0,h,0x0);
			}
			i+=packing;
		}
	}else{
		//gbv_EDIB
		for(signed int h=0;h<(-(long)height);h++){
			for(unsigned int w=0;w<width;w++){
				if(0==w%8)i++;
				if(mask[w%8]&data[i-1]) SetPixel(hdc,w+0,h,0xFFFFFF); else SetPixel(hdc,w+0,h,0x0);
			}
			i+=packing;
		}
	}
}

//Frbg 4 ̕`
void paint4(HDC hdc,unsigned char*data,unsigned long*palet,signed long height,unsigned long width){
	unsigned long packing=0;
	const int mask[]={0xF0,0x0F};

	unsigned long pos=width;
	if(width%2) pos=width+(2-width%2);
	pos=pos/2;
	if(pos%4)	packing=4-(pos%4);

	unsigned int i=0;
	if(0<(long)height){
		for(signed int h=height-1;0<=h;h--){
			for(unsigned int w=0;w<width;w++){
				if(0==w%2)i++;
				int pos=mask[w%2]&data[i-1];
				if(0==w%2) pos=pos>>4;
				SetPixel(hdc,w,h,RGB(((unsigned char*)&palet[pos])[2],((unsigned char*)&palet[pos])[1],((unsigned char*)&palet[pos])[0]));
			}
			i+=packing;
		}
	}else{
		//gbv_EDIB
		for(signed int h=0;h<(-(long)height);h++){
			for(unsigned int w=0;w<width;w++){
				if(0==w%2)i++;
				int pos=mask[w%2]&data[i-1];
				if(0==w%2) pos=pos>>4;
				SetPixel(hdc,w,h,RGB(((unsigned char*)&palet[pos])[2],((unsigned char*)&palet[pos])[1],((unsigned char*)&palet[pos])[0]));
			}
			i+=packing;
		}
	}
}

//Frbg 4 + OS2 ̕`
void paint4os2(HDC hdc,unsigned char*data,unsigned char*palet,signed long height,unsigned long width){
	unsigned long packing=0;
	const int mask[]={0xF0,0x0F};

	unsigned long pos=width;
	if(width%2) pos=width+(2-width%2);
	pos=pos/2;
	if(pos%4)	packing=4-(pos%4);

	unsigned int i=0;
	if(0<(long)height){
		for(signed int h=height-1;0<=h;h--){
			for(unsigned int w=0;w<width;w++){
				if(0==w%2)i++;
				int pos=mask[w%2]&data[i-1];
				if(0==w%2) pos=pos>>4;
				pos=pos*3;
				SetPixel(hdc,w,h,RGB(palet[pos+2],palet[pos+1],palet[pos]));
			}
			i+=packing;
		}
	}else{
		//gbv_EDIB
		for(signed int h=0;h<(-(long)height);h++){
			for(unsigned int w=0;w<width;w++){
				if(0==w%2)i++;
				int pos=mask[w%2]&data[i-1];
				if(0==w%2) pos=pos>>4;
				pos=pos*3;
				SetPixel(hdc,w,h,RGB(palet[pos+2],palet[pos+1],palet[pos]));
			}
			i+=packing;
		}
	}
}

//Frbg 4 + RunLengthk̕`
void paint4rle(HDC hdc,unsigned char*data,unsigned long*palet,signed long height,unsigned long width){
	printf("%s\n","RunLength 4 bits/pixel");
	unsigned long packing=0;
	const int mask[]={0xF0,0x0F};

	unsigned int i=0;
	if(0<(long)height){
		for(signed int h=height-1;0<=h;h--){
			for(unsigned int w=0;w<width;){
				int pos=data[i];
				i++;
				int pos2=data[i];
				i++;
				if(pos){
					//R[h[h
					for(int j=0;j<pos;j++){
						int pos3=mask[j%2]&pos2;
						if(0==j%2) pos3=pos3>>4;
						SetPixel(hdc,w,h,RGB(((unsigned char*)&palet[pos3])[2],((unsigned char*)&palet[pos3])[1],((unsigned char*)&palet[pos3])[0]));
						w++;
					}
				}else{
					//΃[h
					for(int j=0;j<pos2;j++){
						if(0==j%2)i++;
						int pos3=mask[j%2]&data[i-1];
						if(0==j%2) pos3=pos3>>4;
						SetPixel(hdc,w,h,RGB(((unsigned char*)&palet[pos3])[2],((unsigned char*)&palet[pos3])[1],((unsigned char*)&palet[pos3])[0]));
						w++;
					}
				}
				//f[^2oCgEɂ낦
				if(i%2) i++;
			}
		}
	}else{
		//gbv_EDIB
		for(signed int h=0;h<(-(long)height);h++){
			for(unsigned int w=0;w<width;){
				int pos=data[i];
				i++;
				int pos2=data[i];
				i++;
				if(pos){
					//R[h[h
					for(int j=0;j<pos;j++){
						int pos3=mask[j%2]&pos2;
						if(0==j%2) pos3=pos3>>4;
						SetPixel(hdc,w,h,RGB(((unsigned char*)&palet[pos3])[2],((unsigned char*)&palet[pos3])[1],((unsigned char*)&palet[pos3])[0]));
						w++;
					}
				}else{
					//΃[h
					for(int j=0;j<pos2;j++){
						if(0==j%2)i++;
						int pos3=mask[j%2]&data[i-1];
						if(0==j%2) pos3=pos3>>4;
						SetPixel(hdc,w,h,RGB(((unsigned char*)&palet[pos3])[2],((unsigned char*)&palet[pos3])[1],((unsigned char*)&palet[pos3])[0]));
						w++;
					}
				}
				//f[^2oCgEɂ낦
				if(i%2) i++;
			}
		}
	}
}

//Frbg 8 ̕`
void paint8(HDC hdc,unsigned char*data,unsigned long*palet,signed long height,unsigned long width){
	unsigned long packing=0;
	if(width%4)	packing=4-(width%4);

	unsigned int i=0;
	if(0<(long)height){
		for(signed int h=height-1;0<=h;h--){
			for(unsigned int w=0;w<width;w++){
				i++;
				int pos=data[i-1];
				SetPixel(hdc,w,h,RGB(((unsigned char*)&palet[pos])[2],((unsigned char*)&palet[pos])[1],((unsigned char*)&palet[pos])[0]));
			}
			i+=packing;
		}
	}else{
		//gbv_EDIB
		for(signed int h=0;h<(-(long)height);h++){
			for(unsigned int w=0;w<width;w++){
				i++;
				int pos=data[i-1];
				SetPixel(hdc,w,h,RGB(((unsigned char*)&palet[pos])[2],((unsigned char*)&palet[pos])[1],((unsigned char*)&palet[pos])[0]));
			}
			i+=packing;
		}
	}
}

//Frbg 8 + OS2 ̕`
void paint8os2(HDC hdc,unsigned char*data,unsigned char*palet,signed long height,unsigned long width){
	unsigned long packing=0;
	if(width%4)	packing=4-(width%4);

	unsigned int i=0;
	if(0<(long)height){
		for(signed int h=height-1;0<=h;h--){
			for(unsigned int w=0;w<width;w++){
				i++;
				int pos=data[i-1]*3;
				SetPixel(hdc,w,h,RGB(palet[pos+2],palet[pos+1],palet[pos]));
			}
			i+=packing;
		}
	}else{
		//gbv_EDIB
		for(signed int h=0;h<(-(long)height);h++){
			for(unsigned int w=0;w<width;w++){
				i++;
				int pos=data[i-1]*3;
				SetPixel(hdc,w,h,RGB(palet[pos+2],palet[pos+1],palet[pos]));
			}
			i+=packing;
		}
	}
}

//Frbg 8 + RunLengthk̕`
void paint8rle(HDC hdc,unsigned char*data,unsigned long*palet,signed long height,unsigned long width){
	printf("%s\n","RunLength 8 bits/pixel");

	unsigned int i=0;
	if(0<(long)height){
		for(signed int h=height-1;0<=h;h--){
			for(unsigned int w=0;w<width;){
				int pos=data[i];
				i++;
				int pos2=data[i];
				i++;
				if(pos){
					//R[h[h
					for(int j=0;j<pos;j++){
						SetPixel(hdc,w,h,RGB(((unsigned char*)&palet[pos2])[2],((unsigned char*)&palet[pos2])[1],((unsigned char*)&palet[pos2])[0]));
						w++;
					}
				}else{
					//΃[h
					for(int j=0;j<pos2;j++){
						int pos3=data[i];
						i++;
						SetPixel(hdc,w,h,RGB(((unsigned char*)&palet[pos3])[2],((unsigned char*)&palet[pos3])[1],((unsigned char*)&palet[pos3])[0]));
						w++;
					}
				}
				//f[^2oCgEɂ낦
				if(i%2) i++;
			}
		}
	}else{
		//gbv_EDIB
		for(signed int h=0;h<(-(long)height);h++){
			for(unsigned int w=0;w<width;){
				int pos=data[i];
				i++;
				int pos2=data[i];
				i++;
				if(pos){
					//R[h[h
					for(int j=0;j<pos;j++){
						SetPixel(hdc,w,h,RGB(((unsigned char*)&palet[pos2])[2],((unsigned char*)&palet[pos2])[1],((unsigned char*)&palet[pos2])[0]));
						w++;
					}
				}else{
					//΃[h
					for(int j=0;j<pos2;j++){
						int pos3=data[i];
						i++;
						SetPixel(hdc,w,h,RGB(((unsigned char*)&palet[pos3])[2],((unsigned char*)&palet[pos3])[1],((unsigned char*)&palet[pos3])[0]));
						w++;
					}
				}
				//f[^2oCgEɂ낦
				if(i%2) i++;
			}
		}
	}
}

//Frbg 16 ̕`
void paint16(HDC hdc,unsigned char*data,signed long height,unsigned long width){
	//̃oCgvZ@l̔{ɂ邽߂̋lߕvZB
	unsigned long packing=0;
	if((width*2)%4)	packing=4-((width*2)%4);

	unsigned int i=0;
	if(0<(long)height){
		for(signed int h=height-1;0<=h;h--){
			for(unsigned int w=0;w<width;w++){
				//RGB555
				int r=(0x7C00&(*((short*)&data[i])))>>10;
				int g=(0x3E0&(*((short*)&data[i])))>>5;
				int b=(0x1F&(*((short*)&data[i])));
				SetPixel(hdc,w,h,RGB(r<<3,g<<3,b<<3));
				i+=2;
			}
			i+=packing;
		}
	}else{
		//gbv_EDIB
		for(signed int h=0;h<(-(long)height);h++){
			for(unsigned int w=0;w<width;w++){
				//RGB555
				int r=(0x7C00&(*((short*)&data[i])))>>10;
				int g=(0x3E0&(*((short*)&data[i])))>>5;
				int b=(0x1F&(*((short*)&data[i])));
				SetPixel(hdc,w,h,RGB(r<<3,g<<3,b<<3));
				i+=2;
			}
			i+=packing;
		}
	}
}

//Frbg 16 + Bitfields̕`
void paint16bf(HDC hdc,unsigned char*data,unsigned long*table,signed long height,unsigned long width){
	//̃oCgvZ@l̔{ɂ邽߂̋lߕvZB
	unsigned long packing=0;
	if((width*2)%4)	packing=4-((width*2)%4);

	unsigned long mask1=table[0];
	unsigned long mask2=table[1];
	unsigned long mask3=table[2];

	//32bit̃}XN8bit݂̂ĂԂɐ`
	fix8bit(&mask1);
	fix8bit(&mask2);
	fix8bit(&mask3);

	//}XÑVtgvZ
	unsigned long pos;
	int r_s=0,g_s=0,b_s=0;
	pos=mask1;
	while(!(0x01&pos))	pos=mask1>>(++r_s);
	pos=mask2;
	while(!(0x01&pos))	pos=mask2>>(++g_s);
	pos=mask3;
	while(!(0x01&pos))	pos=mask3>>(++b_s);

	//8bitɂ낦VtgvZ
	int r_m=0,g_m=0,b_m=0;
	r_m=8-bitcount(mask1);
	g_m=8-bitcount(mask2);
	b_m=8-bitcount(mask3);

	unsigned int i=0;
	if(0<(long)height){
		for(signed int h=height-1;0<=h;h--){
			for(unsigned int w=0;w<width;w++){
				SetPixel(hdc,w,h,RGB(
					(((*((unsigned short*)&data[i]))&mask1)>>r_s)<<r_m,
					(((*((unsigned short*)&data[i]))&mask2)>>g_s)<<g_m,
					(((*((unsigned short*)&data[i]))&mask3)>>b_s)<<b_m
					));
				i+=2;
			}
			i+=packing;
		}
	}else{
		//gbv_EDIB
		for(signed int h=0;h<(-(long)height);h++){
			for(unsigned int w=0;w<width;w++){
				SetPixel(hdc,w,h,RGB(
					(((*((unsigned short*)&data[i]))&mask1)>>r_s)<<r_m,
					(((*((unsigned short*)&data[i]))&mask2)>>g_s)<<g_m,
					(((*((unsigned short*)&data[i]))&mask3)>>b_s)<<b_m
					));
				i+=2;
			}
			i+=packing;
		}
	}
}

//Frbg 24 ̕`
void paint24(HDC hdc,unsigned char*data,signed long height,unsigned long width){
	//̃oCgvZ@l̔{ɂ邽߂̋lߕvZB
	unsigned long packing=0;
	if((width*3)%4)	packing=4-((width*3)%4);

	unsigned int i=0;
	if(0<(long)height){
		for(signed int h=height-1;0<=h;h--){
			for(unsigned int w=0;w<width;w++){
				SetPixel(hdc,w,h,RGB(data[i+2],data[i+1],data[i]));
				i+=3;
			}
			i+=packing;
		}
	}else{
		//gbv_EDIB
		for(signed int h=0;h<(-(long)height);h++){
			for(unsigned int w=0;w<width;w++){
				SetPixel(hdc,w,h,RGB(data[i+2],data[i+1],data[i]));
				i+=3;
			}
			i+=packing;
		}
	}
}

//Frbg 32 ̕`
void paint32(HDC hdc,unsigned char*data,signed long height,unsigned long width){
	unsigned int i=0;
	if(0<(long)height){
		for(signed int h=height-1;0<=h;h--){
			for(unsigned int w=0;w<width;w++){
				SetPixel(hdc,w,h,RGB(data[i+2],data[i+1],data[i]));
				i+=4;
			}
		}
	}else{
		//gbv_EDIB
		for(signed int h=0;h<(-(long)height);h++){
			for(unsigned int w=0;w<width;w++){
				SetPixel(hdc,w,h,RGB(data[i+2],data[i+1],data[i]));
				i+=4;
			}
		}
	}
}

//Frbg 32 + Bitfields̕`
void paint32bf(HDC hdc,unsigned char*data,unsigned long*table,signed long height,unsigned long width){
	unsigned long mask1=table[0];
	unsigned long mask2=table[1];
	unsigned long mask3=table[2];

	//32bit̃}XN8bit݂̂ĂԂɐ`
	fix8bit(&mask1);
	fix8bit(&mask2);
	fix8bit(&mask3);

	//}XÑVtgvZ
	unsigned long pos;
	int r_s=0,g_s=0,b_s=0;
	pos=mask1;
	while(!(0x01&pos))	pos=mask1>>(++r_s);
	pos=mask2;
	while(!(0x01&pos))	pos=mask2>>(++g_s);
	pos=mask3;
	while(!(0x01&pos))	pos=mask3>>(++b_s);

	//8bitɂ낦VtgvZ
	int r_m=0,g_m=0,b_m=0;
	r_m=8-bitcount(mask1);
	g_m=8-bitcount(mask2);
	b_m=8-bitcount(mask3);

	unsigned int i=0;
	if(0<(long)height){
		for(signed int h=height-1;0<=h;h--){
			for(unsigned int w=0;w<width;w++){
				SetPixel(hdc,w,h,RGB(
					(((*((unsigned long*)&data[i]))&mask1)>>r_s)<<r_m,
					(((*((unsigned long*)&data[i]))&mask2)>>g_s)<<g_m,
					(((*((unsigned long*)&data[i]))&mask3)>>b_s)<<b_m
					));
				i+=4;
			}
		}
	}else{
		//gbv_EDIB
		for(signed int h=0;h<(-(long)height);h++){
			for(unsigned int w=0;w<width;w++){
				SetPixel(hdc,w,h,RGB(
					(((*((unsigned long*)&data[i]))&mask1)>>r_s)<<r_m,
					(((*((unsigned long*)&data[i]))&mask2)>>g_s)<<g_m,
					(((*((unsigned long*)&data[i]))&mask3)>>b_s)<<b_m
					));
				i+=4;
			}
		}
	}
}

char str[1024];
unsigned long HeaderSize;
unsigned char*Data;
unsigned long Offset;
unsigned long Datasize;
unsigned long Width;
unsigned long Height;
unsigned long BitCount;
unsigned long BitCompression;

HBITMAP Bitmap;
HDC BitmapDC;

//_CAOvV[W[
BOOL CALLBACK DlgProc1(HWND hDlg,UINT msg,WPARAM wp,LPARAM lp){
	switch (msg){
		case WM_SHOWWINDOW:
			//ACR̐ݒ
			SendMessage(hDlg, WM_SETICON,NULL,(LPARAM)LoadIcon((HINSTANCE)GetWindowLong(hDlg, GWL_HINSTANCE),  MAKEINTRESOURCE(IDI_ICON1)));
			sprintf(str,"%s %s","rbg}bvr[A[",VERSION);
			SetWindowText(hDlg,str);
			break;
		case WM_DROPFILES:
			DragQueryFile((HDROP)wp,0,str,1024);//hbOꂽ0ڂłB
			printf("\n%s\n",str);
			//rbg}bvj
			if(BitmapDC){
				DeleteDC(BitmapDC);
				DeleteObject(Bitmap);
				BitmapDC=NULL;
			}
			if(load(str)) SetWindowText(hDlg,"G[");
			InvalidateRect(hDlg, NULL,1);
			UpdateWindow(hDlg);
			break;
		case WM_SIZE:
			InvalidateRect(hDlg, NULL,1);
			UpdateWindow(hDlg);
			break;
		case WM_ERASEBKGND://wi̕`ƂɂB
			return TRUE;
		case WM_PAINT:
			{
				RECT crc;
				GetClientRect(hDlg,&crc);

				int w=(crc.right-crc.left);
				int h=(crc.bottom-crc.top);

				PAINTSTRUCT ps;
				HDC hdc=BeginPaint(hDlg,&ps);
				//wiʂԂ
				HBRUSH brush = CreateSolidBrush(RGB(255,255,255));//uV̍쐬
				SelectObject(hdc,brush);//uV̓Kp
				Rectangle(hdc,0,0,w,h);//lpɓhԂ
				DeleteObject(brush);//uV̔j

				//rbg}bvʂɓ]
				if(BitmapDC){
					double pos;
					if(((double)h/(double)Height)<((double)w/(double)Width)){
						pos=(double)h/(double)Height;
					}else{
						pos=(double)w/(double)Width;
					}

					sprintf(str,"%g %%\n",pos*100);
					SetWindowText(hDlg,str);

					int _h=(int)((double)Height*pos);
					int _w=(int)((double)Width*pos);
					
					StretchBlt(hdc,(w-_w)/2,(h-_h)/2,_w,_h,BitmapDC,0,0,Width,Height,SRCCOPY );
				}else{
					TextOut(hdc,10,10,(LPCTSTR)"rbg}bvt@ChbOAhhbvĂ",(int)28*2);
				}
				EndPaint(hDlg,&ps);
			}
			break;
		case WM_CLOSE:
			DestroyWindow(hDlg);
			PostQuitMessage(0);
		break;
	}
	return FALSE;
}

#define HEADER (14)

int load(char*filename){
	FILE * fp;
	unsigned char header[15];

	if((fp=fopen(filename,"rb"))==NULL){
		//G[
		return -1;
	}else{
		//Œwb_[ǂ TCY14byte
		if(HEADER!=fread(header,sizeof(char),HEADER,fp)){
			printf("ǂݍ݃G[\n");
			return -1;
		}
		
		if('B'!=header[0] || 'M'!=header[1]){
			printf("BITMAPł͂܂\n");
			return -1;
		}

		printf("%d byte\n",*(unsigned long*)&header[2]);
		printf("%d 摜f[^܂ł̃ItZbg\n",*(unsigned long*)&header[10]);
		Offset=(*(unsigned long*)&header[10])-HEADER;
		Datasize=*(unsigned long*)&header[2]-HEADER;
		if(Data) free(Data);
		Data=(unsigned char*)malloc(Datasize * sizeof(unsigned char));
		if (Data == NULL){
			printf("mۃG[\n");
			return -1;
		}
		{
			unsigned int pos;
			if(Datasize!=(pos=fread(Data,sizeof(char),Datasize,fp))){
				printf("ǂݍ݃G[2\n");
				printf("%d\n",pos);
				return -1;
			}
		}
		fclose(fp);

		printf("%d byte wb_̃TCY\n",*(unsigned long*)&Data[14-HEADER]);
		HeaderSize=*(unsigned long*)&Data[14-HEADER];

		//OS2tH[}bg
		if(12==*(unsigned long*)&Data[14-HEADER]){
			printf("%s\n","OS2tH[}bg");
			printf("%d pix 摜̕\n",*(unsigned short*)&Data[18-HEADER]);
			printf("%d pix 摜̍\n",*(unsigned short*)&Data[20-HEADER]);
			printf("%d bit 1fbit\n",*(unsigned short*)&Data[24-HEADER]);
	
			BitCompression=0;
			Width=*((unsigned short*)&Data[18-HEADER]);
			Height=*((unsigned short*)&Data[20-HEADER]);
			BitCount=*((unsigned short*)&Data[24-HEADER]);
		}else{
			printf("%d pix 摜̕\n",*(unsigned long*)&Data[18-HEADER]);
			printf("%d pix 摜̍\n",*(unsigned long*)&Data[22-HEADER]);
			printf("%d bit 1fbit\n",*(unsigned short*)&Data[28-HEADER]);
			printf("%d 摜f[^̃TCY\n",*(unsigned long*)&Data[34-HEADER]);
			printf("%d k`\n",*(unsigned long*)&Data[30-HEADER]);

			printf("%d ppm 𑜓x\n",*(unsigned long*)&Data[38-HEADER]);
			printf("%d ppm 𑜓x\n",*(unsigned long*)&Data[42-HEADER]);
			printf("%d pbg̐F\n",*(unsigned long*)&Data[46-HEADER]);
			printf("%x dṽpbg̃CfbNX\n",*(unsigned long*)&Data[50-HEADER]);

			BitCompression=*(unsigned long*)&Data[30-HEADER];
			Width=*((unsigned long*)&Data[18-HEADER]);
			Height=*((unsigned long*)&Data[22-HEADER]);
			BitCount=*((unsigned short*)&Data[28-HEADER]);
		}

		//Ȉk`͑ΉĂȂB
		if(3<BitCompression) return -1;

/*		//rbg}bvj
		if(BitmapDC){
			DeleteDC(BitmapDC);
			DeleteObject(Bitmap);
			BitmapDC=NULL;
		}
*/
		//rbg}bv̍쐬
		HDC hdc=GetDC(hDlg);
		BitmapDC=CreateCompatibleDC(hdc);
		if(0<=(signed long)Height){
			Bitmap=CreateCompatibleBitmap(hdc,Width,Height);
		}else{
			Bitmap=CreateCompatibleBitmap(hdc,Width,0-(signed long)Height);
		}
		SelectObject(BitmapDC,Bitmap);
		ReleaseDC(hDlg,hdc);

		if(1==BitCount){
			paint1(BitmapDC,Data+Offset,(signed long)Height,Width);
		}else if(4==BitCount){
			if(12==HeaderSize){
				//OS2
				paint4os2(BitmapDC,Data+Offset,(unsigned char*)(Data+HeaderSize),(signed long)Height,Width);
			}else if(0==BitCompression){
				paint4(BitmapDC,Data+Offset,(unsigned long*)(Data+HeaderSize),(signed long)Height,Width);
			}else if(2==BitCompression){
				//RunLength 4 bits/pixel
				paint4rle(BitmapDC,Data+Offset,(unsigned long*)(Data+HeaderSize),(signed long)Height,Width);
			}
		}else if(8==BitCount){
			if(12==HeaderSize){
				//OS2
				paint8os2(BitmapDC,Data+Offset,(unsigned char*)(Data+HeaderSize),(signed long)Height,Width);
			}else if(0==BitCompression){
				paint8(BitmapDC,Data+Offset,(unsigned long*)(Data+HeaderSize),(signed long)Height,Width);
			}else if(1==BitCompression){
				//RunLength 8 bits/pixel
				paint8rle(BitmapDC,Data+Offset,(unsigned long*)(Data+HeaderSize),(signed long)Height,Width);
			}
		}else if(16==BitCount){
			if(0==BitCompression){
				paint16(BitmapDC,Data+Offset,(signed long)Height,Width);
			}else if(3==BitCompression){
				//BITFIELDS wb_[TCYp^[܂ޏꍇƊ܂܂Ȃꍇ݂Ă邽ߌߑłłSOɂ
				paint16bf(BitmapDC,Data+Offset,(unsigned long*)(Data+40),(signed long)Height,Width);
			}
		}else if(24==BitCount){
			paint24(BitmapDC,Data+Offset,(signed long)Height,Width);
		}else if(32==BitCount){
			if(0==BitCompression){
				paint32(BitmapDC,Data+Offset,(signed long)Height,Width);
			}else if(3==BitCompression){
				//BITFIELDS
				paint32bf(BitmapDC,Data+Offset,(unsigned long*)(Data+40),(signed long)Height,Width);
			}
		}
		//gbv_EDIBł̕`悪IĂ邽߁A}CiX̏ꍇ̓vXɂ
		if(0>(signed long)Height) Height=0-(signed long)Height;
	}
	return 0;
}